#include <sys/fd.h>
#include "struct.h"
#include "extern.h"

/****************************************************************************/
/*Function chmod_msg()                                                      */
/*              This function is called when the IO_CHMOD message           */
/*              is receive.  this function will change the read,            */
/*              write and execute permissions of the driver to              */
/*              what is received in the message.                            */
/*     Parameters Passed:                                                   */
/*      pid :Process ID of calling application.                             */
/****************************************************************************/
int chmod_msg(pid_t pid)
{
  struct ocb *ocb;
  uid_t uid;
  gid_t gid;
   
  if ((ocb = get_ocb(pid, io_msg.chmod.fd)) == -1)
  {
    io_msg.status = EBADF;
    return (REPLY);
  }
    // Get group and user id of calling process.
  get_ids(pid, &uid, &gid);
    /*
     * ROOT  anytime
     * OWNER anytime
     * GROUP never
     * OTHER never
     */
  if (uid == 0 || uid == tmk_stat.st_uid)
  {
    tmk_stat.st_mode = tmk_stat.st_mode & ~0777 | (io_msg.chmod.mode & 0777);   /* Change access modes. */
    tmk_stat.st_ctime = *timep; // Time of last status change.
    io_msg.status = EOK;
  }
  else
    io_msg.status = EACCES;
  return (REPLY);
}
