#include <sys/fd.h>
#include "struct.h"
#include "proto.h"
#include "extern.h"

/****************************************************************************/
/*Function chown_msg()                                                      */
/*              This function is called when the IO_CHOWN message           */
/*              is received.  This function will change the                 */
/*              ownership of the driver to what is received in the          */
/*              message.                                                    */
/*     Parameters Passed:                                                   */
/*      pid :Process ID of calling application.                             */
/****************************************************************************/
int chown_msg(pid_t pid)
{
  uid_t uid;
  gid_t gid;
  struct ocb *ocb;

  if ((ocb = get_ocb(pid, io_msg.chown.fd)) == -1)
  {
     io_msg.status = EBADF;
     return (REPLY);
  }

  get_ids(pid, &uid, &gid);
    /*
     * ROOT  anytime
     * OWNER (can change group, but not owner)
     * GROUP never
     * OTHER never
     */
  if (uid == 0 || (uid == tmk_stat.st_uid && io_msg.chown.uid == tmk_stat.st_uid))
  {
    tmk_stat.st_uid = io_msg.chown.uid;  /* Change user ID.  */
    tmk_stat.st_gid = io_msg.chown.gid;  /* Change group ID. */
    tmk_stat.st_ctime = *timep;        /* Time of last status change.*/
    io_msg.status = EOK;
  }
  else
    io_msg.status = EACCES;
  return (REPLY);
}
