#include <string.h>
#include <sys/fd.h>
#include "define.h"
#include "struct.h"
#include "extern.h"

/****************************************************************************/
/*Function fstat_msg()                                                      */
/*              This function is call when the IO_FSTAT message is          */
/*              received. This function will reply with the fstat           */
/*              structure which is kept updated throughout the              */
/*              driver in the appropriate functions.                        */
/*     Parameters Passed:                                                   */
/*      pid :  Process ID of calling application.                           */
/****************************************************************************/
int fstat_msg(pid_t pid)
{
  struct ocb *ocb;
   
  if ((ocb = get_ocb(pid, io_msg.fstat.fd)) == -1)
  {
    io_msg.status = EBADF;
    return (REPLY);
  }
  
  memcpy(&io_msg.fstat_reply.stat, &tmk_stat, sizeof(struct stat));
  io_msg.fstat_reply.status = EOK;

  return (REPLY);
}
/****************************************************************************/
/*Function stat_msg()                                                       */
/*              This function is called when the IO_STAT message            */
/*              is received.  This function will reply with the             */
/*              fstat_reply structure to the calling application.           */
/*     Parameters Passed:                                                   */
/*      pid :Process ID of calling application.                             */
/****************************************************************************/
int stat_msg(pid_t pid)
{
  if (io_msg.open.path[0] == NULL)
  {
    memcpy(&io_msg.fstat_reply.stat, &tmk_stat, sizeof(struct stat));
    io_msg.fstat_reply.status = EOK;
  }
  else
  {
    io_msg.status = ENOENT;
    return (REPLY);
  }
  io_msg.status = EOK;
  return (REPLY);
}
