#include <fcntl.h>
#include <sys/fd.h>
#include "struct.h"
#include "define.h"
#include "extern.h"

/****************************************************************************/
/*Function utime_msg()                                                      */
/*              This function is called when the touch command is           */
/*              the driver  (/dev/___). It will update the access           */
/*              time stamp to the current time.                             */
/*     Parameters Pass :                                                    */
/*      pid :PID of calling process.                                        */
/****************************************************************************/
int utime_msg(pid_t pid)
{
  struct ocb *ocb;
   
  if ((ocb = get_ocb(pid, io_msg.utime.fd)) == -1)
  {
    io_msg.status = EBADF;
    return (REPLY);
  }
    /* Calling process must have write permission. */
  if (!(ocb->mode & S_IWRITE) || ((ocb->oflags & O_ACCMODE) == O_WRONLY))
  {
    io_msg.utime_reply.status = EBADF;
    return (REPLY);
  }
  
  if (io_msg.utime.cur_flag) /* Set to current time.*/
  {
    tmk_stat.st_atime = *timep;
    tmk_stat.st_mtime = *timep;
    io_msg.fstat_reply.stat.st_atime = *timep;
    io_msg.fstat_reply.stat.st_mtime = *timep;
  }
  else               /* Set to time passed with message.*/
  {
    tmk_stat.st_mtime = io_msg.utime.modtime;
    tmk_stat.st_atime = io_msg.utime.actime;
    io_msg.fstat_reply.stat.st_mtime = io_msg.utime.modtime;
    io_msg.fstat_reply.stat.st_atime = io_msg.utime.actime;
  }
  io_msg.utime_reply.status = EOK;
  return (REPLY);
}
