/****************************************************************************/
/*      TMK1553B 32-bit v3.04 for QNX. ELCUS, 1997,2009.                    */
/*      MIL-STD-1553B Terminal Input/Output Manager for QNX.                */
/****************************************************************************/

//#define __VERBOSE

#include <errno.h>
#include <sys/kernel.h>
#include <sys/proxy.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "struct.h"
#include "define.h"

#include "tmkllq4.h"
#include "tmkstat.h"

#define TMK1553B_VERSION 0x0304
// don't forget to change version in fputs(), io_sys.c and usemsg.txt!

int hTmk;

int nMaxTmkNumber = MAX_TMK_NUMBER;

//#define MRT_READ_BRC_DATA 1
//#define MRT_WRITE_BRC_DATA 1
unsigned long adwTmkOptions[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];

//unsigned short awBrcRxBuf[MAX_TMK_NUMBER+1][1024];
unsigned short awBrcRxBuf[1][1024];

TTmkConfig aTmkConfig[MAX_TMK_NUMBER+1];

/*
typedef struct
{
  int nIrq;
  int cTmks;
  int hTmk[MAX_TMK_NUMBER+1];
} TIrq;

TIrq ahIrq[MAX_TMK_NUMBER+1];

int cIrqs = 0;
*/

TListEvD aEvData[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1][EVENTS_SIZE];
int iEvDataBegin[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];
int iEvDataEnd[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];
int cEvData[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];
int cDpcData[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];

union msg     io_msg;  /* union of all possible message types to the driver */
struct stat   tmk_stat;
time_t __far  *timep;
void          *fd_ctrl;
int           devno;
int           devnort[MAX_RT_NUMBER+1];
pid_t         tmk_proxy;
char          devicename[25];
char          devicenamert[32];
int           id;

int           fIgnoreTestError = 0;

int fMultiTmk;

unsigned short wTmkMode[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];
unsigned short wTmkModeDeep[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];
//unsigned short wTmkMaxBase;
//unsigned short wTmkMaxPage;

unsigned short wTmkMinBase;

struct ocb *pTmkLockOCB[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];
struct ocb *pTmkStartOCB = NULL;
struct ocb *pRtAnswLockOCB[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];
struct ocb *pRtArbLockOCB[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];

unsigned short wBase = 0xFFFF;
unsigned short wDir = 0xFFFF;
unsigned short wSubAddr = 0xFFFF;
unsigned short wLockDir;
unsigned short wLockSubAddr;
unsigned short wTmkBus = BUS_A;

int fTmkChanged = 0;

int short nLen;
unsigned short awBuf[64];

struct ocb FirstOCB[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];
struct ocb *pOCB;

volatile int iPxD[MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1];

TTmkProxyData NoProxyData = { 0, 0 };

typedef struct
{
  int short dummy;
  TTmkProxyData ProxyData;
} TTmkEv2Px;

unsigned wPort1 = 0xFFFF, wPort2 = 0xFFFF, nIrq1 = 0xFF, nIrq2 = 0xFF;
unsigned short nTmkType = 0xFFFF;
unsigned short iszTmkType;
char szTmkType[8] = "";
char *aszTmkTypes[] = {
  "TMK400",
  "TMKMPC","TMKMP","MTMK400",
  "RTMK400",
  "TMKX",
  "TMKXI",
  "MRTX",
  "MRTXI",
  "TA",
  "TAI",
  "" };
unsigned short anTmkTypes[] = {
  2,
  3,3,3,
  4,
  5,
  6,
  7,
  8,
  9,
  10,
  0xFFFF };

int short afPars[MAX_TMK_TYPE+1] = { 255, 255, 23, 21, 21, 21, 19, 21, 19, 21, 19 };
int short fPars;

#ifdef __VERBOSE
short int verbose = 0;   /* verbose level */
#endif

void main(int argc, char *argv[])
{
  pid_t pid;
  char reply;
  int opt;

  int priority;

  struct _mxfer_entry mx[2];
  struct ocb *ocb;

  priority = 24;
  devicename[0] = '\0';
//  devicenamert[0] = '\0';

  for (hTmk = 0; hTmk < MAX_TMK_NUMBER+1+MAX_RT_NUMBER+1; ++hTmk)
  {
    FirstOCB[hTmk].tmkProxy = 0;
    FirstOCB[hTmk].wModeDeep = 0;
    FirstOCB[hTmk].wProxyMode = 0;
    FirstOCB[hTmk].pNext = NULL;
    iPxD[hTmk] = 0;
    adwTmkOptions[hTmk] = MRT_READ_BRC_DATA | MRT_WRITE_BRC_DATA;
    wTmkMode[hTmk] = UNDEFINED_MODE;
    wTmkModeDeep[hTmk] = 0;
    pTmkLockOCB[hTmk] = NULL;
    pRtAnswLockOCB[hTmk] = NULL;
    pRtArbLockOCB[hTmk] = NULL;
  }

  for (hTmk = 0; hTmk <= MAX_TMK_NUMBER; ++hTmk)
  {
    aTmkConfig[hTmk].nTmk = hTmk;
    aTmkConfig[hTmk].nType = -1;
//    aTmkConfig[hTmk].szName[0] = '\0';
    aTmkConfig[hTmk].wPorts1 = aTmkConfig[hTmk].wPorts2 = 0;
//    aTmkConfig[hTmk].wIrq1 = aTmkConfig[hTmk].wIrq2 = 0;
    aTmkConfig[hTmk].wHiddenPorts = 0;
//    aTmkConfig[hTmk].fIrqShared = 0;
//    aTmkConfig[hTmk].nDev = 0;
//    aTmkConfig[hTmk].nSubDev = 0;
    iEvDataBegin[hTmk] = iEvDataEnd[hTmk] = cEvData[hTmk] = cDpcData[hTmk] = 0;
  }
  
  fPars = 0;
  while ((opt = getopt(argc, argv, "a:b:d:e:i:p:t:V")) != -1)
  {
    switch (opt)
    {
      case 'a': sscanf(optarg, "%X", &wPort1); fPars |= 1;
            break;
      case 'b': sscanf(optarg, "%X", &wPort2); fPars |= 2;
            break;
      case 'i': sscanf(optarg, "%d", &nIrq1); fPars |= 4;
            break;
      case 't': strncpy(szTmkType, optarg, 8); fPars |= 16;
            break;
      case 'd': strncpy(devicename, optarg, 24);
            break;
      case 'p': priority = atoi(optarg);
            break;
      case 'e': 
            if (*optarg == 'y')
              fIgnoreTestError = 0;
            else if (*optarg == 'n')
              fIgnoreTestError = 1;
            break;
      case 'V':
#ifdef __VERBOSE
            ++verbose;
#endif
            break;
      default:  break;
    }
  }

  for (iszTmkType = 0; *aszTmkTypes[iszTmkType] != '\0'; ++iszTmkType)
  {
    if (strcmp(szTmkType, aszTmkTypes[iszTmkType]) == 0)
    {
      nTmkType = anTmkTypes[iszTmkType];
      break;
    }
  }
  if (*aszTmkTypes[iszTmkType] == '\0')
  {
    perror("tmk1553b:main:-t unknown type error");
    exit(-1);
  }
  if (nTmkType == TMKXI || nTmkType == MRTXI || nTmkType == TAI)
    fPars |= 2;
  if (afPars[nTmkType] != fPars)
  {
    perror("tmk1553b:main:params error");
    exit(-1);
  }

  if (nTmkType == MRTX || nTmkType == MRTXI)
  {
    nMaxTmkNumber = 4;
    fMultiTmk = 1;
    if (devicename[0] == '\0')
      strcpy(devicename, DEVICE_NAME_MRT);
//    if (devicenamert[0] == '\0')
//      strcpy(devicenamert, DEVICE_NAME_RT0);
  }
  else
  {
    fMultiTmk = 0;
    if (devicename[0] == '\0')
      strcpy(devicename, DEVICE_NAME_TMK);
  }

  hardware_init();  /* do any hardware setup required when initializing */

  manager_init(priority);   /* initialize the resource manager */

  fputs("MIL-STD-1553B card 32-bit driver started. v3.04 (c) ELCUS, 1997,2009.\n", stderr);

  tmkselect(hTmk = 0);
  for (;;)         /* Message processing loop. */
  {
    pid = Receive(0, &io_msg, sizeof(io_msg));
      /* After receiving message call function to process it if it is */
      /* supported.  Reply with ENOSYS if not supported. */
      /* 'pid' is the process id of the process that sent us a message */
#ifdef __VERBOSE
    if (verbose)
      print_event(io_msg.type, pid);
#endif
    
    if (pid == tmk_proxy)
    {
      tmkDpcRoutine();
      continue;
    }
    else if (io_msg.type == _IO_TMKLL)
    {
#define SS_0 0
//    case _IO_TMKLL:
#ifdef __VERBOSE
        if (verbose)
          print_my_event(io_msg.io_tmkll.subtype);
#endif
        if ((ocb = get_ocb(pid, io_msg.io_tmkll.fd)) == -1)
        {
          reply = REPLY;
          io_msg.status = EBADF;
        }
        else
        {
          if (fMultiTmk && ocb->wTmkNumber != tmkselected())
          {
            tmkselect(hTmk = ocb->wTmkNumber);
            fTmkChanged = 1;
          }
          switch (io_msg.io_tmkll.subtype)
          {
          case SS_TMKDEFMODE:
            io_msg.tdm_r.status = EOK;
            reply = REPLY;
            if (io_msg.tdm.wMode == wTmkMode[hTmk])
            {
              ++ocb->wModeDeep;
              ++wTmkModeDeep[hTmk];
              break;
            }
            if (wTmkMode[hTmk] == UNDEFINED_MODE)
            {
              switch (io_msg.tdm.wMode)
              {
              case BC_MODE:
                if (!(io_msg.tdm_r.status = bcreset()))
                {
//                  wTmkMaxBase = bcgetmaxbase();
                  wTmkMode[hTmk] = BC_MODE;
                  ocb->wModeDeep = 1;
                  wTmkModeDeep[hTmk] = 1;
                  wBase = 0xFFFF;
                }
                break;
              case RT_MODE:
                if (!(io_msg.tdm_r.status = rtreset()))
                {
//                  wTmkMaxPage = rtgetmaxpage();
                  wTmkMode[hTmk] = RT_MODE;
                  ocb->wModeDeep = 1;
                  wTmkModeDeep[hTmk] = 1;
                  wDir = 0xFFFF;
                }
                break;
              case MT_MODE:
                if (!(io_msg.tdm_r.status = mtreset()))
                {
//                  wTmkMaxBase = mtgetmaxbase();
                  wTmkMode[hTmk] = MT_MODE;
                  ocb->wModeDeep = 1;
                  wTmkModeDeep[hTmk] = 1;
                  wBase = 0xFFFF;
                }
                break;
              default:
                io_msg.tdm_r.status = TMK_BAD_MODE;
                break;
              }
              break;
            }
            io_msg.tdm_r.status = TMK_OTHER_MODE;
            break;
          case SS_TMKUNDEFMODE:
            reply = REPLY;
            if (ocb->wModeDeep > 0)
            {
              --ocb->wModeDeep;
              if (--wTmkModeDeep[hTmk] == 0)
              {
                if (wTmkMode[hTmk] == RT_MODE)
                  rtenable(RT_DISABLE);
                wTmkMode[hTmk] = UNDEFINED_MODE;
              }
              io_msg.tudm_r.status = EOK;
              break;
            }
            io_msg.tudm_r.status = TMK_BAD_MODE;
            break;
          case SS_TMKGETMODE:
            reply = REPLY;
            io_msg.tgm_r.wMode = wTmkMode[hTmk];
            io_msg.tgm_r.status = EOK;
            break;
          case SS_BCRESET:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
            {
              io_msg.br_r.status = bcreset();
              wBase = 0xFFFF;
            }
            else
            {
              io_msg.br_r.status = TMK_OTHER_LOCK;
            }
            break;
          case SS_RTRESET:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
            {
              io_msg.rr_r.status = rtreset();
              wDir = 0xFFFF;
            }
            else
            {
              io_msg.rr_r.status = TMK_OTHER_LOCK;
            }
            break;
          case SS_MTRESET:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
            {
              io_msg.mr_r.status = mtreset();
              wBase = 0xFFFF;
            }
            else
            {
              io_msg.mr_r.status = TMK_OTHER_LOCK;
            }
            break;
          case SS_TMKDEFPROXY:
            reply = REPLY;
            io_msg.tdp_r.status = EOK;
            ocb->tmkProxy = io_msg.tdp.Proxy;
            if (ocb->tmkProxy == 0)
            {
              for (pOCB = &FirstOCB[hTmk]; pOCB != NULL; pOCB = pOCB->pNext)
              {
                if (pOCB->pNext == ocb)
                {
                  pOCB->pNext = pOCB->pNext->pNext;
                  break;
                }
              }
            }
            else
            {
              int f = 0;
              for (pOCB = &FirstOCB[hTmk]; pOCB != NULL; pOCB = pOCB->pNext)
              {
                if (pOCB->pNext == ocb)
                {
                  f = 1;
                  break;
                }
              }
              if (!f)
              {
                ocb->pNext = FirstOCB[hTmk].pNext;
                FirstOCB[hTmk].pNext = ocb;
              }
            }
            break;
          case SS_TMKMAKEPROXY:
            reply = REPLY;
            if ((ocb->tmkProxy = qnx_proxy_attach(io_msg.tmp.ProcessId, &aEvData, sizeof(TTmkProxyData), -1)) != -1)
            {
              int f = 0;
              io_msg.tmp_r.status = EOK;
              io_msg.tmp_r.Proxy = ocb->tmkProxy;
              for (pOCB = &FirstOCB[hTmk]; pOCB != NULL; pOCB = pOCB->pNext)
              {
                if (pOCB->pNext == ocb)
                {
                  f = 1;
                  break;
                }
              }
              if (!f)
              {
                ocb->pNext = FirstOCB[hTmk].pNext;
                FirstOCB[hTmk].pNext = ocb;
              }
            }
            else
            {
              ocb->tmkProxy = 0;
              for (pOCB = &FirstOCB[hTmk]; pOCB != NULL; pOCB = pOCB->pNext)
              {
                if (pOCB->pNext == ocb)
                {
                  pOCB->pNext = pOCB->pNext->pNext;
                  break;
                }
              }
            }
            break;
          case SS_TMKGETPXD:
            io_msg.tgpd_r.status = EOK;
            _setmx(&mx[0], &io_msg, sizeof(io_msg.tgpd_r)-sizeof(TTmkProxyData));
            if (ocb->wProxyMode)
            {
              if (ocb->ciPxD)
              {
                _setmx(&mx[1], &(((TTmkEv2Px*)&aEvData[hTmk][ocb->aiPxD[ocb->iiPxD]])->ProxyData), sizeof(TTmkProxyData));
//                _disable();
                ocb->iiPxD = (ocb->iiPxD + 1) & 511;
                --ocb->ciPxD;
//                _enable();
              }
              else
                _setmx(&mx[1], &NoProxyData, sizeof(TTmkProxyData));
            }
            else
              _setmx(&mx[1], &(((TTmkEv2Px*)&aEvData[hTmk][iPxD[hTmk]])->ProxyData), sizeof(TTmkProxyData));
            Replymx(pid, 2, &mx);
            reply = NO_REPLY;
            break;
          case SS_BCGETMAXBASE:
            reply = REPLY;
            io_msg.bgmb_r.wMaxBase = bcgetmaxbase();
            io_msg.bgmb_r.status = EOK;
            break;
          case SS_BCGETW:
            reply = REPLY;
            if (io_msg.bgw.wBase != wBase)
            {
              if (io_msg.bgw_r.status = bcdefbase(io_msg.bgw.wBase))
                break;
              else
                wBase = io_msg.bgw.wBase;
            }
            else
              io_msg.bgw_r.status = EOK;
            io_msg.bgw_r.wData = bcgetw(io_msg.bgw.wAddr);
            break;
          case SS_BCPUTW:
            reply = REPLY;
            if (io_msg.bpw.wBase != wBase)
            {
              if (io_msg.bpw_r.status = bcdefbase(io_msg.bpw.wBase))
                break;
              else
                wBase = io_msg.bpw.wBase;
            }
            else
              io_msg.bpw_r.status = EOK;
            bcputw(io_msg.bpw.wAddr, io_msg.bpw.wData);
            break;
          case SS_BCGETBLK:
            if (io_msg.bgbl.wBase != wBase)
            {
              if (io_msg.bgbl_r.status = bcdefbase(io_msg.bgbl.wBase))
              {
                reply = REPLY;
                break;
              }
              else
                wBase = io_msg.bgbl.wBase;
            }
            bcgetblk(io_msg.bgbl.wAddr, awBuf, io_msg.bgbl.wLen);
            if (io_msg.bgbl_r.status = tmkError)
            {
              reply = REPLY;
              break;
            }
            _setmx(&mx[0], &io_msg, sizeof(io_msg.bgbl_r)-sizeof(io_msg.bgbl_r.data));
            _setmx(&mx[1], &awBuf, io_msg.bgbl.wLen<<1);
            Replymx(pid, 2, &mx);
            reply = NO_REPLY;
            break;
          case SS_BCPUTBLK:
            reply = REPLY;
            if (io_msg.bpbl.wBase != wBase)
            {
              if (io_msg.bpbl_r.status = bcdefbase(io_msg.bpbl.wBase))
                break;
              else
                wBase = io_msg.bpbl.wBase;
            }
            if ((nLen = Readmsg(pid, sizeof(io_msg.bpbl)-sizeof(io_msg.bpbl.data),
                        awBuf, io_msg.bpbl.wLen<<1)) == -1)
            {
              io_msg.bpbl_r.status = errno;
              break;
            }
            nLen >>= 1;
            bcputblk(io_msg.bpbl.wAddr, awBuf, io_msg.bpbl.wLen);
            io_msg.bpbl_r.status = tmkError;
            break;
          case SS_BCDEFBUS:
            reply = REPLY;
            if (pTmkLockOCB[hTmk] == ocb)
            {
              if (!(io_msg.bdbs_r.status = bcdefbus(io_msg.bdbs.wBus)))
                wTmkBus = ocb->bcBus = io_msg.bdbs.wBus;
            }
            else
            {
              io_msg.bdbs_r.status = TMK_OTHER_LOCK;
            }
            break;
          case SS_BCGETBUS:
            reply = REPLY;
            io_msg.bgbs_r.wBus = ocb->bcBus;
            io_msg.bgbs_r.status = EOK;
            break;
          case SS_BCSTART:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
            {
              pTmkStartOCB = ocb;
              if (ocb->bcBus != wTmkBus)
                bcdefbus(wTmkBus = ocb->bcBus);
              io_msg.bst_r.status = bcstart(io_msg.bst.wBase, io_msg.bst.wCtrlCode);
            }
            else
            {
              io_msg.bst_r.status = TMK_OTHER_LOCK;
            }
            break;
          case SS_BCSTARTX:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
            {
              pTmkStartOCB = ocb;
              io_msg.bsx_r.status = bcstartx(io_msg.bsx.wBase, io_msg.bsx.wCtrlCode);
            }
            else
            {
              io_msg.bsx_r.status = TMK_OTHER_LOCK;
            }
            break;
          case SS_BCGETANSW:
            reply = REPLY;
            if (io_msg.bgaw.wBase != wBase)
            {
              if (!(io_msg.bgaw_r.status = bcdefbase(io_msg.bgaw.wBase)))
                wBase = io_msg.bgaw.wBase;
              else
                break;
            }
            io_msg.bgaw_r.l.AWs = bcgetansw(io_msg.bgaw.wCtrlCode);
            io_msg.bgaw_r.status = EOK;
            break;
          case SS_BCDEFLINK:
            reply = REPLY;
            if (io_msg.bdl.wBase != wBase)
            {
              if (!(io_msg.bdl_r.status = bcdefbase(io_msg.bdl.wBase)))
                wBase = io_msg.bdl.wBase;
              else
                break;
            }
            io_msg.bdl_r.status = bcdeflink(io_msg.bdl.wNextBase, io_msg.bdl.wCtrlCode);
            break;
          case SS_BCGETLINK:
            reply = REPLY;
            if (io_msg.bgl.wBase != wBase)
            {
              if (!(io_msg.bgl_r.status = bcdefbase(io_msg.bgl.wBase)))
                wBase = io_msg.bgl.wBase;
              else
                break;
            }
            io_msg.bgl_r.l.Link = bcgetlink();
            io_msg.bgl_r.status = EOK;
            break;
          case SS_BCSTOP:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
              io_msg.bsp_r.status = bcstop();
            else
              io_msg.bsp_r.status = TMK_OTHER_LOCK;
            break;
          case SS_BCGETSTATE:
            reply = REPLY;
            io_msg.bgs_r.l.State = bcgetstate();
            io_msg.bgs_r.status = EOK;
            break;
          case SS_RTGETMAXPAGE:
            reply = REPLY;
            io_msg.rgmp_r.wMaxPage = rtgetmaxpage();
            io_msg.rgmp_r.status = EOK;
            break;
          case SS_RTDEFPAGE:
            reply = REPLY;
            io_msg.rdp_r.status = rtdefpage(io_msg.rdp.wPage);
            wDir = 0xFFFF;
            break;
          case SS_RTGETPAGE:
            reply = REPLY;
            io_msg.rgp_r.wPage = rtgetpage();
            io_msg.rgp_r.status = EOK;
            break;
          case SS_RTDEFPAGEPC:
            reply = REPLY;
            io_msg.rdpp_r.status = rtdefpagepc(io_msg.rdpp.wPage);
            wDir = 0xFFFF;
            break;
          case SS_RTDEFPAGEBUS:
            reply = REPLY;
            io_msg.rdpb_r.status = rtdefpagebus(io_msg.rdpb.wPage);
            break;
          case SS_RTGETPAGEPC:
            reply = REPLY;
            io_msg.rgpp_r.wPage = rtgetpagepc();
            io_msg.rgpp_r.status = EOK;
            break;
          case SS_RTGETPAGEBUS:
            reply = REPLY;
            io_msg.rgpb_r.wPage = rtgetpagebus();
            io_msg.rgpb_r.status = EOK;
            break;
          case SS_RTDEFADDRESS:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
              io_msg.rda_r.status = rtdefaddress(io_msg.rda.wAddress);
            else
              io_msg.rda_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTGETADDRESS:
            reply = REPLY;
            io_msg.rga_r.wAddress = rtgetaddress();
            io_msg.rga_r.status = EOK;
            break;
          case SS_RTGETW:
            reply = REPLY;
            if (fTmkChanged || (io_msg.rgw.wSubAddr != wSubAddr || io_msg.rgw.wDir != wDir))
            {
              rtdefsubaddr(io_msg.rgw.wDir, io_msg.rgw.wSubAddr);
              wSubAddr = io_msg.rgw.wSubAddr;
              wDir = io_msg.rgw.wDir;
//printf("gw%x,%x;", wDir, wSubAddr);
            }
            io_msg.rgw_r.wData = rtgetw(io_msg.rgw.wAddr);
            io_msg.rgw_r.status = EOK;
            break;
          case SS_RTPUTW:
            reply = REPLY;
            if (fTmkChanged || (io_msg.rpw.wSubAddr != wSubAddr || io_msg.rpw.wDir != wDir))
            {
              rtdefsubaddr(io_msg.rpw.wDir, io_msg.rpw.wSubAddr);
              wSubAddr = io_msg.rpw.wSubAddr;
              wDir = io_msg.rpw.wDir;
//printf("pw%x,%x;", wDir, wSubAddr);
            }
            rtputw(io_msg.rpw.wAddr, io_msg.rpw.wData);
            io_msg.rpw_r.status = EOK;
            break;
          case SS_RTGETBLK:
            if (fTmkChanged || (io_msg.rgbl.wSubAddr != wSubAddr || io_msg.rgbl.wDir != wDir))
            {
              rtdefsubaddr(io_msg.rgbl.wDir, io_msg.rgbl.wSubAddr);
              wSubAddr = io_msg.rgbl.wSubAddr;
              wDir = io_msg.rgbl.wDir;
//printf("gb%x,%x;", wDir, wSubAddr);
            }
            rtgetblk(io_msg.rgbl.wAddr, awBuf, io_msg.rgbl.wLen);
            if (io_msg.rgbl_r.status = tmkError)
            {
              reply = REPLY;
              break;
            }
            _setmx(&mx[0], &io_msg, sizeof(io_msg.rgbl_r)-sizeof(io_msg.rgbl_r.data));
            _setmx(&mx[1], &awBuf, io_msg.rgbl.wLen<<1);
            Replymx(pid, 2, &mx);
            reply = NO_REPLY;
            break;
          case SS_RTPUTBLK:
            reply = REPLY;
            if (fTmkChanged || (io_msg.rpbl.wSubAddr != wSubAddr || io_msg.rpbl.wDir != wDir))
            {
              rtdefsubaddr(io_msg.rpbl.wDir, io_msg.rpbl.wSubAddr);
              wSubAddr = io_msg.rpbl.wSubAddr;
              wDir = io_msg.rpbl.wDir;
//printf("pb%x,%x;", wDir, wSubAddr);
            }
            if ((nLen = Readmsg(pid, sizeof(io_msg.rpbl)-sizeof(io_msg.rpbl.data),
                        awBuf, io_msg.rpbl.wLen<<1)) == -1)
            {
              io_msg.rpbl_r.status = errno;
              break;
            }
            nLen >>= 1;
            rtputblk(io_msg.rpbl.wAddr, awBuf, io_msg.rpbl.wLen);
            io_msg.rpbl_r.status = tmkError;
            break;
          case SS_RTSETANSWBITS:
            reply = REPLY;
            if (ocb == pRtAnswLockOCB[hTmk])
            {
              rtsetanswbits(io_msg.rsab.wBits);
              io_msg.rsab_r.status = EOK;
            }
            else
              io_msg.rsab_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTCLRANSWBITS:
            reply = REPLY;
            if (ocb == pRtAnswLockOCB[hTmk])
            {
              rtclranswbits(io_msg.rcab.wBits);
              io_msg.rcab_r.status = EOK;
            }
            else
              io_msg.rcab_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTGETANSWBITS:
            reply = REPLY;
            io_msg.rgab_r.wBits = rtgetanswbits();
            io_msg.rgab_r.status = EOK;
            break;
          case SS_RTGETFLAGS:
            io_msg.rgfs_r.status = EOK;
            if ((nLen = ((io_msg.rgfs.wMaxFlag & 0x1F) - (io_msg.rgfs.wMinFlag & 0x1F) + 1)) <= 0)
            {
              reply = REPLY;
              break;
            }
            wDir = 0xFFFF;
            rtgetflags(awBuf, io_msg.rgfs.wDir, io_msg.rgfs.wMinFlag, io_msg.rgfs.wMaxFlag);
            _setmx(&mx[0], &io_msg, sizeof(io_msg.rgfs_r) - sizeof(io_msg.rgfs_r.data));
            _setmx(&mx[1], &awBuf, nLen<<1);
            Replymx(pid, 2, &mx);
            reply = NO_REPLY;
            break;
          case SS_RTPUTFLAGS:
            reply = REPLY;
            io_msg.rpfs_r.status = EOK;
            if ((nLen = ((io_msg.rpfs.wMaxFlag & 0x1F) - (io_msg.rpfs.wMinFlag & 0x1F) + 1)) <= 0)
              break;
            if ((nLen = Readmsg(pid, sizeof(io_msg.rpfs) - sizeof(io_msg.rpfs.data),
                        awBuf, nLen<<1)) == -1)
            {
              io_msg.rpfs_r.status = errno;
              break;
            }
            nLen >>= 1;
            wDir = 0xFFFF;
            rtputflags(awBuf, io_msg.rpfs.wDir, io_msg.rpfs.wMinFlag, io_msg.rpfs.wMaxFlag);
            break;
          case SS_RTSETFLAG:
            reply = REPLY;
            rtsetflag(io_msg.rsf.wDir, io_msg.rsf.wSubAddr);
            wDir = 0xFFFF;
            io_msg.rsf_r.status = EOK;
            break;
          case SS_RTCLRFLAG:
            reply = REPLY;
            rtclrflag(io_msg.rcf.wDir, io_msg.rcf.wSubAddr);
            wDir = 0xFFFF;
            io_msg.rcf_r.status = EOK;
            break;
          case SS_RTGETFLAG:
            reply = REPLY;
            io_msg.rgf_r.wFlag = rtgetflag(io_msg.rgf.wDir, io_msg.rgf.wSubAddr);
            wDir = 0xFFFF;
            io_msg.rgf_r.status = EOK;
            break;
          case SS_RTGETSTATE:
            reply = REPLY;
            io_msg.rgs_r.wState = rtgetstate();
            io_msg.rgs_r.status = EOK;
            break;
          case SS_RTBUSY:
            reply = REPLY;
            if (ocb == pRtArbLockOCB[hTmk])
            {
              io_msg.rb_r.fBusy = rtbusy();
//printf("b%x,%x=%d;", wDir, wSubAddr, io_msg.rb_r.fBusy);
              io_msg.rb_r.status = EOK;
            }
            else
            {
              io_msg.rb_r.fBusy = 0;
              io_msg.rb_r.status = TMK_OTHER_LOCK;
            }
            break;
          case SS_RTLOCK:
            reply = REPLY;
            if (ocb == pRtArbLockOCB[hTmk])
            {
              rtlock(io_msg.rl.wDir, io_msg.rl.wSubAddr);
                wSubAddr = io_msg.rl.wSubAddr;
                wDir = io_msg.rl.wDir;
              wLockDir = io_msg.rl.wDir;
              wLockSubAddr = io_msg.rl.wSubAddr;
              io_msg.rl_r.status = EOK;
            }
            else
              io_msg.rl_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTUNLOCK:
            reply = REPLY;
            if (ocb == pRtArbLockOCB[hTmk])
            {
//              rtdefsubaddr(io_msg.rul.wDir, io_msg.rul.wSubAddr);
//              rtunlock(io_msg.rul.wDir, io_msg.rul.wSubAddr);
//printf("u%x,%x;", io_msg.rul.wDir, io_msg.rul.wSubAddr);
              rtdefsubaddr(io_msg.rul.wDir, io_msg.rul.wSubAddr);
              if ((io_msg.rul.wSubAddr != wSubAddr || io_msg.rul.wDir != wDir))
              {
                wSubAddr = io_msg.rul.wSubAddr;
                wDir = io_msg.rul.wDir;
              }
              wLockDir = io_msg.rul.wDir;
              wLockSubAddr = io_msg.rul.wSubAddr;
              io_msg.rul_r.status = EOK;
            }
            else
              io_msg.rul_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTGETCMDDATA:
            reply = REPLY;
            io_msg.rgcd_r.wData = rtgetcmddata(io_msg.rgcd.wBusCmd);
            io_msg.rgcd_r.status = EOK;
            wDir = 0xFFFF;
            break;
          case SS_RTPUTCMDDATA:
            reply = REPLY;
            rtputcmddata(io_msg.rpcd.wBusCmd, io_msg.rpcd.wData);
            io_msg.rpcd_r.status = EOK;
            wDir = 0xFFFF;
            break;
          case SS_RTDEFMODE:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
              io_msg.rdm_r.status = rtdefmode(io_msg.rdm.wMode);
            else
              io_msg.rdm_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTGETMODE:
            reply = REPLY;
            io_msg.rgm_r.wMode = rtgetmode();
            io_msg.rgm_r.status = EOK;
            break;
          case SS_TMKSETCWBITS:
            reply = REPLY;
            tmksetcwbits(io_msg.tscb.wBits);
            io_msg.tscb_r.status = EOK;
            break;
          case SS_TMKCLRCWBITS:
            reply = REPLY;
            tmkclrcwbits(io_msg.tccb.wBits);
            io_msg.tccb_r.status = EOK;
            break;
          case SS_TMKGETCWBITS:
            reply = REPLY;
            io_msg.tgcb_r.wBits = tmkgetcwbits();
            io_msg.tgcb_r.status = EOK;
            break;
          case SS_MTGETSW:
            reply = REPLY;
            if (io_msg.mgsw.wBase != wBase)
            {
              if (io_msg.mgsw_r.status = mtdefbase(io_msg.mgsw.wBase))
                break;
              else
                wBase = io_msg.mgsw.wBase;
            }
            io_msg.mgsw_r.wData = mtgetsw();
            break;
          case SS_TMK_LOCK:
            reply = REPLY;
            if (pTmkLockOCB[hTmk] == NULL)
            {
              pTmkLockOCB[hTmk] = ocb;
              io_msg.t_l_r.status = EOK;
            }
            else
              io_msg.t_l_r.status = TMK_OTHER_LOCK;
            break;
          case SS_TMK_UNLOCK:
            reply = REPLY;
            if (pTmkLockOCB[hTmk] == ocb)
            {
              pTmkLockOCB[hTmk] = NULL;
              io_msg.t_ul_r.status = EOK;
            }
            else
              io_msg.t_ul_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTARB_LOCK:
            reply = REPLY;
            if (pRtArbLockOCB[hTmk] == NULL)
            {
              pRtArbLockOCB[hTmk] = ocb;
              io_msg.ra_l_r.status = EOK;
            }
            else
              io_msg.ra_l_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTARB_UNLOCK:
            reply = REPLY;
            if (pRtArbLockOCB[hTmk] == ocb)
            {
              pRtArbLockOCB[hTmk] = NULL;
              io_msg.ra_ul_r.status = EOK;
            }
            else
              io_msg.ra_ul_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTANSW_LOCK:
            reply = REPLY;
            if (pRtAnswLockOCB[hTmk] == NULL)
            {
              pRtAnswLockOCB[hTmk] = ocb;
              io_msg.raw_l_r.status = EOK;
            }
            else
              io_msg.raw_l_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTANSW_UNLOCK:
            reply = REPLY;
            if (pRtAnswLockOCB[hTmk] == ocb)
            {
              pRtAnswLockOCB[hTmk] = NULL;
              io_msg.raw_ul_r.status = EOK;
            }
            else
              io_msg.raw_ul_r.status = TMK_OTHER_LOCK;
            break;
          case SS_BC_DEF_TLDW:
            reply = REPLY;
            bc_def_tldw(io_msg.b_d_t.wData);
            io_msg.b_d_t_r.status = EOK;
            break;
          case SS_BC_ENABLE_DI:
            reply = REPLY;
            bc_enable_di();
            io_msg.b_e_d_r.status = EOK;
            break;
          case SS_BC_DISABLE_DI:
            reply = REPLY;
            bc_disable_di();
            io_msg.b_d_d_r.status = EOK;
            break;
          case SS_BCDEFIRQMODE:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
              io_msg.bdim_r.status = bcdefirqmode(io_msg.bdim.wIrqMode&~TMK_IRQ_OFF);
            else
              io_msg.bdim_r.status = TMK_OTHER_LOCK;
            break;
          case SS_BCGETIRQMODE:
            reply = REPLY;
            io_msg.bgim_r.wIrqMode = bcgetirqmode();
            io_msg.bgim_r.status = EOK;
            break;
          case SS_RTDEFIRQMODE:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
              io_msg.rdim_r.status = rtdefirqmode(io_msg.rdim.wIrqMode&~TMK_IRQ_OFF);
            else
              io_msg.rdim_r.status = TMK_OTHER_LOCK;
            break;
          case SS_RTGETIRQMODE:
            reply = REPLY;
            io_msg.rgim_r.wIrqMode = rtgetirqmode();
            io_msg.rgim_r.status = EOK;
            break;
          case SS_TMKGETINFO:
            reply = REPLY;
            io_msg.tgi_r.status = EOK;
            io_msg.tgi_r.tmkType = nTmkType;
            io_msg.tgi_r.tmkPort1 = wPort1;
            io_msg.tgi_r.tmkPort2 = wPort2;
            io_msg.tgi_r.tmkIrq1 = nIrq1;
            io_msg.tgi_r.tmkIrq2 = nIrq2;
            break;
          case SS_BCDEFMINBASE:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
            {
             wTmkMinBase = io_msg.bdnb.wMinBase;
             io_msg.bdnb_r.status = EOK;
            }
            else
             io_msg.bdnb_r.status = TMK_OTHER_LOCK;
            break;
          case SS_BCGETMINBASE:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
            {
             io_msg.bgnb_r.wMinBase = wTmkMinBase;
             io_msg.bgnb_r.status = EOK;
            }
            else
             io_msg.bgnb_r.status = TMK_OTHER_LOCK;
            break;
          case SS_TMKPROXYMODE:
            reply = REPLY;
            io_msg.tpm_r.status = EOK;
            if (io_msg.tpm.wProxyMode != GET_PROXY_MODE)
            {
  //            if (io_msg.tpm.wProxyMode && !ocb->wProxyMode)
              {
//                _disable();
                ocb->ciPxD = 0;
                ocb->iiPxD = 0;
                ocb->wProxyMode = io_msg.tpm.wProxyMode;
//                _enable();
              }
            }
            io_msg.tpm_r.wProxyMode = ocb->wProxyMode;  
            break;
  //        case SS_RTDEFPXMODE:
  //          reply = REPLY;
  //          ocb->fRtCmdProxy = io_msg.rdpm.fCmdProxy;
  //          ocb->fRtErrProxy = io_msg.rdpm.fErrProxy;
  //          ocb->fRtDataProxy = io_msg.rdpm.fDataProxy;
  //          io_msg.rdpm_r.status = EOK;
  //          break;
          case SS_TMKTIMER:
            reply = REPLY;
            io_msg.tt_r.status = EOK;
            io_msg.tt_r.wTimerCtrl = tmktimer(io_msg.tt.wTimerCtrl);
            break;
          case SS_TMKGETTIMER:
            reply = REPLY;
            io_msg.tgt_r.status = EOK;
            io_msg.tgt_r.dwTimer = tmkgettimer();
            break;
          case SS_TMKGETTIMERL:
            reply = REPLY;
            io_msg.tgtl_r.status = EOK;
            io_msg.tgtl_r.wTimer = tmkgettimerl();
            break;
          case SS_BCGETMSGTIME:
            reply = REPLY;
            if (io_msg.bgmt.wBase != wBase)
            {
              if (io_msg.bgmt_r.status = bcdefbase(io_msg.bgmt.wBase))
                break;
              else
                wBase = io_msg.bgmt.wBase;
            }
            else
              io_msg.bgmt_r.status = EOK;
            io_msg.bgmt_r.dwTime = bcgetmsgtime();
            break;
          case SS_RTGETMSGTIME:
            reply = REPLY;
            if (fTmkChanged || (io_msg.rgmt.wSubAddr != wSubAddr || io_msg.rgmt.wDir != wDir))
            {
              rtdefsubaddr(io_msg.rgmt.wDir, io_msg.rgmt.wSubAddr);
              wSubAddr = io_msg.rgmt.wSubAddr;
              wDir = io_msg.rgmt.wDir;
            }
            io_msg.rgmt_r.dwTime = rtgetmsgtime();
            io_msg.rgmt_r.status = EOK;
            break;
          case SS_TMKGETHWVER:
            reply = REPLY;
            io_msg.tghwv_r.status = EOK;
            io_msg.tghwv_r.wHWVer = tmkgethwver();
            break;
          case SS_TMKGETVERSION:
            reply = REPLY;
            io_msg.tGV_r.status = EOK;
            io_msg.tGV_r.wVersion = TMK1553B_VERSION;
            break;
          case SS_RTENABLE:
            reply = REPLY;
            io_msg.re_r.status = EOK;
            io_msg.re_r.wEnable = rtenable(io_msg.re.wEnable);
            break;
          case SS_MRTGETMAXN:
/*
struct __mrtgetmaxn
{
  unsigned short type;
  unsigned short subtype;
  short int fd;
};
struct __mrtgetmaxn_reply
{
  short int status;
  unsigned short wMrtMaxN;
};
#define SS_MRTCONFIG 0x55 ?
#define SS_MRTSELECTED 0x56 ?
*/
          case SS_MRTGETSTATE:
            reply = REPLY;
            io_msg.mrgs_r.status = EOK;
            io_msg.mrgs_r.wState = mrtgetstate();
            break;
          case SS_MRTDEFBRCSUBADDR0:
            reply = REPLY;
            io_msg.mrdbsa0_r.status = EOK;
            mrtdefbrcsubaddr0(); //!!!
            wDir = 0xFFFF;
            break;
          case SS_MRTRESET:
            reply = REPLY;
            if (ocb == pTmkLockOCB[hTmk])
            {
              io_msg.mrr_r.dwResult = bcreset();
              io_msg.mrr_r.status = (io_msg.mrr_r.dwResult != 0) ? EOK : TMK_BAD_MODE;
            }
            else
            {
              io_msg.mrr_r.status = TMK_OTHER_LOCK;
            }
            break;
          case SS_TMKGETPXTIME:
            reply = REPLY;
            io_msg.tgpt_r.status = EOK;
            io_msg.tgpt_r.dwTime = 0;
            break;
          case SS_TMKSWTIMER:
            reply = REPLY;
            io_msg.tswt_r.status = EOK;
            io_msg.tswt_r.wTimerCtrl = 0; //tmkswtimer(io_msg.tswt.wTimerCtrl);
            break;
          case SS_TMKGETSWTIMER:
            reply = REPLY;
            io_msg.tgswt_r.status = EOK;
            io_msg.tgswt_r.dwTimer = 0L; //tmkgetswtimer();
            break;
          case SS_TMKTIMEOUT:
            reply = REPLY;
            io_msg.tto_r.status = EOK;
            io_msg.tto_r.wTimeOut = tmktimeout(io_msg.tto.wTimeOut);
            break;
          case SS_0:
          default:
            io_msg.status = ENOSYS;
            reply = REPLY;
            break;
          }
          fTmkChanged = 0;
        }
//      break;        
    }
    else if (io_msg.type == _SYSMSG)
    {
//    case _SYSMSG: /* when a 'sin ver' is run this message comes in */
        reply = sys_msg(pid);
//      break;
    }
    else switch (io_msg.type)
    {
      case _IO_HANDLE:
        reply = handle_msg(pid);
        break;

            /* an open request. Comes from an open() call */
      case _IO_OPEN:   
        reply = open_msg(pid);
        break;

            /* a close request. Either from a close() call or from termination */
            /* of the program. The Operating System ensures that even if a */
            /* client dies abnormally, if it has a file descriptor open to */
            /* your manager, your program will ALWAYS receive a close message. */
            /* Note that this is NETWORK TRANSPARENT.. it works both for */
            /* locally opened devices and devices opened across the network. */
      case _IO_CLOSE:   
        reply = close_msg(pid);
        break;

            /* a request to duplicate the file descriptor. ddup() */
      case _IO_DUP:
        reply = dup_msg(pid);
        break;

            /*  file status request */
      case _IO_FSTAT:
        reply = fstat_msg(pid);  
        break;
        
            /* status request */
      case _IO_STAT:
        reply = stat_msg(pid);   
        break;

            /* chmod() request */
      case _IO_CHMOD:
        reply = chmod_msg(pid);
        break;

            /* change ownership */
      case _IO_CHOWN:
        reply = chown_msg(pid);
        break;

            /* update the device access time */
      case _IO_UTIME:
        reply = utime_msg(pid);
        break;

            /* read some data */
      case _IO_READ:
        reply = read_msg(pid);
        break;
      
             /* write some data */
      case _IO_WRITE:
        reply = write_msg(pid);
        break;

      
            /* these message types are currently not supported */
      case _IO_QIOCTL:
      case _IO_CHDIR:
      case _IO_READDIR:
      case _IO_REWINDDIR:
      case _IO_LSEEK:
      case _IO_RENAME:
      case _IO_GET_CONFIG:
      case _IO_FLAGS:
      case _IO_LOCK:
      default:
        io_msg.status = ENOSYS;
        reply = REPLY;
        break;
    }
    if (reply)
      Reply(pid, &io_msg, sizeof(io_msg));
  }
}

#ifdef __VERBOSE
void print_event(int msgtype, pid_t pid)
{
  char msg[30][15] = {"SYS_MSG","_IO_OPEN","_IO_CLOSE","_IO_READ","_IO_WRITE",
                      "_IO_LSEEK","_IO_RENAME","_IO_GET_CONFIG","_IO_DUP",
                      "_IO_HANDLE","_IO_FSTAT","_IO_CHMOD","_IO_CHOWN",
                      "_IO_UTIME","_IO_FLAGS","_IO_LOCK","_IO_CHDIR", "???",
                      "_IO_READDIR","_IO_REWINDDIR","_IO_IOCTL","_IO_STAT",
                      "_IO_SELECT","_IO_QIOCTL"};
  if (msgtype > 23)
    msgtype = 0;
  fprintf(stderr, "Received message from %d. Type = %s\n\r", pid, &msg[msgtype&0xff][0]);
}
void print_my_event(int msgsubtype)
{
  fprintf(stderr, "Received message subtype is %d\n\r", msgsubtype);
}
#endif
